Whamcloud - gitweb
LU-10931 tests: stop running recovery-small 136
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
index 73f13cf..365be60 100755 (executable)
@@ -2,9 +2,6 @@
 
 set -e
 
-#         bug  5493  LU2034
-ALWAYS_EXCEPT="52    60      $RECOVERY_SMALL_EXCEPT"
-
 export MULTIOP=${MULTIOP:-multiop}
 PTLDEBUG=${PTLDEBUG:--1}
 LUSTRE=${LUSTRE:-`dirname $0`/..}
@@ -13,16 +10,19 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
+ALWAYS_EXCEPT="$RECOVERY_SMALL_EXCEPT"
+if [ "$MDSCOUNT" -gt "1" ]; then
+       # bug number for skipped test: LU-10931
+       ALWAYS_EXCEPT+="               136"
+       # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
+fi
+
 require_dsh_mds || exit 0
 
 # also long tests: 19, 21a, 21e, 21f, 23, 27
 
 [ "$SLOW" = "no" ] && EXCEPT_SLOW=""
 
-[ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
-# bug number for skipped test:       LU-2547
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 24a 24b"
-
 build_test_filter
 
 # Allow us to override the setup if we already have a mounted system by
@@ -215,7 +215,7 @@ test_10c() {
                  awk '{sub("_UUID", "", $2); print $2;}')
        #assume one client
        mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
-       conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       conn_uuid=$($LCTL get_param -n mdc.${mdccli}.conn_uuid)
        mdcpath="mdc.${mdccli}.import=connection=${conn_uuid}"
 
        drop_bl_callback_once "chmod 0777 ${workdir}" &
@@ -286,6 +286,45 @@ test_10d() {
 }
 run_test 10d "test failed blocking ast"
 
+test_10e()
+{
+       [[ $(lustre_version_code ost1) -le $(version_code 2.8.58) ]] &&
+               skip "Need OST version at least 2.8.59" && return 0
+       [ $CLIENTCOUNT -lt 2 ] && skip "need two clients" && return 0
+       [ $(facet_host client) == $(facet_host ost1) ] &&
+               skip "need ost1 and client on different nodes" && return 0
+       local -a clients=(${CLIENTS//,/ })
+       local client1=${clients[0]}
+       local client2=${clients[1]}
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile-1 $DIR/$tfile-2
+       $MULTIOP $DIR/$tfile-1 Ow1048576c
+
+#define OBD_FAIL_LDLM_BL_CALLBACK_NET                   0x305
+       $LCTL set_param fail_loc=0x80000305
+
+#define OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT 0x30e
+       do_facet ost1 "$LCTL set_param fail_loc=0x1000030e"
+       # hit OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT twice:
+       # 1. to return ENOTCONN from ldlm_handle_enqueue0
+       # 2. to pause reconnect handling between resend and setting
+       # import to LUSTRE_IMP_FULL state
+       do_facet ost1 "$LCTL set_param fail_val=3"
+
+       # client1 fails ro respond to bl ast
+       do_node $client2 "$MULTIOP $DIR/$tfile-1 Ow1048576c" &
+       MULTIPID=$!
+
+       # ost1 returns error on enqueue, which causes client1 to reconnect
+       do_node $client1 "$MULTIOP $DIR/$tfile-2 Ow1048576c" ||
+               error "multiop failed"
+       wait $MULTIPID
+
+       do_facet ost1 "$LCTL set_param fail_loc=0"
+       do_facet ost1 "$LCTL set_param fail_val=0"
+}
+run_test 10e "re-send BL AST vs reconnect race 2"
+
 #bug 2460
 # wake up a thread waiting for completion after eviction
 test_11(){
@@ -390,7 +429,7 @@ test_16() {
 }
 run_test 16 "timeout bulk put, don't evict client (2732)"
 
-test_17() {
+test_17a() {
     local at_max_saved=0
 
     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
@@ -424,7 +463,93 @@ test_17() {
     [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
     return 0
 }
-run_test 17 "timeout bulk get, don't evict client (2732)"
+run_test 17a "timeout bulk get, don't evict client (2732)"
+
+test_17b() {
+       [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
+
+       # get one of the clients from client list
+       local rcli=$(echo $RCLIENTS | cut -d ' ' -f 1)
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       local ldlm_enqueue_min=$(do_facet ost1 find /sys -name ldlm_enqueue_min)
+       [ -z "$ldlm_enqueue_min" ] &&
+               skip "missing /sys/.../ldlm_enqueue_min" && return 0
+
+       $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/$tfile ||
+               error "setstripe failed"
+       $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/${tfile}2 ||
+               error "setstripe 2 failed"
+
+       save_lustre_params ost1 "at_history" > $p
+       save_lustre_params ost1 "bulk_timeout" >> $p
+       local dev="${FSNAME}-OST0000"
+       save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
+       local ldlm_enqueue_min_save=$(do_facet ost1 cat $ldlm_enqueue_min)
+
+       local new_at_history=15
+
+       do_facet ost1 "$LCTL set_param at_history=$new_at_history"
+       do_facet ost1 "$LCTL set_param bulk_timeout=30"
+       do_facet ost1 "echo 30 > /sys/module/ptlrpc/parameters/ldlm_enqueue_min"
+
+       # brw_size is required to be 4m so that bulk transfer timeout
+       # could be simulated with OBD_FAIL_PTLRPC_CLIENT_BULK_CB3
+       local brw_size=$($LCTL get_param -n \
+           osc.$FSNAME-OST0000-osc-[^M]*.import |
+           awk '/max_brw_size/{print $2}')
+       if [ $brw_size -ne 4194304 ]
+       then
+               save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
+               do_facet ost1 "$LCTL set_param obdfilter.$dev.brw_size=4"
+               remount_client $MOUNT
+       fi
+
+       # get service estimate expanded
+       #define OBD_FAIL_OST_BRW_PAUSE_PACK              0x224
+       do_facet ost1 "$LCTL set_param fail_loc=0x80000224 fail_val=35"
+       echo "delay rpc servicing by 35 seconds"
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=fdatasync
+
+       local estimate
+       estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
+           awk '/portal 6/ {print $5}')
+       echo "service estimates increased to $estimate"
+
+       # let current worst service estimate to get closer to obliteration
+       sleep $((new_at_history / 3))
+
+       # start i/o and simulate bulk transfer loss
+       #define OBD_FAIL_PTLRPC_CLIENT_BULK_CB3     0x520
+       do_facet ost1 "$LCTL set_param fail_loc=0xa0000520 fail_val=1"
+       dd if=/dev/zero of=$DIR/$tfile bs=2M count=1 conv=fdatasync,notrunc &
+       local writedd=$!
+
+       # start lock conflict handling
+       sleep $((new_at_history / 3))
+       do_node $rcli "dd if=$DIR/$tfile of=/dev/null bs=1M count=1" &
+       local readdd=$!
+
+       # obliterate the worst service estimate
+       sleep $((new_at_history / 3 + 1))
+       dd if=/dev/zero of=$DIR/${tfile}2 bs=1M count=1
+
+       estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
+           awk '/portal 6/ {print $5}')
+       echo "service estimate dropped to $estimate"
+
+       wait $writedd
+       [[ $? == 0 ]] || error "write failed"
+       wait $readdd
+       [[ $? == 0 ]] || error "read failed"
+
+       restore_lustre_params <$p
+       if [ $brw_size -ne 4194304 ]
+       then
+               remount_client $MOUNT || error "remount_client failed"
+       fi
+       do_facet ost1 "echo $ldlm_enqueue_min_save > $ldlm_enqueue_min"
+}
+run_test 17b "timeout bulk get, dont evict client (3582)"
 
 test_18a() {
     [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
@@ -912,7 +1037,8 @@ test_24b() {
 
        dmesg -c > /dev/null
        mkdir -p $DIR/$tdir
-       lfs setstripe $DIR/$tdir -s 0 -i 0 -c 1
+       lfs setstripe $DIR/$tdir -S 0 -i 0 -c 1 ||
+               error "$LFS setstripe failed"
        cancel_lru_locks osc
        multiop_bg_pause $DIR/$tdir/$tfile-1 Ow8192_yc ||
                error "mulitop Ow8192_yc failed"
@@ -954,20 +1080,21 @@ test_26a() {      # was test_26 bug 5921 - evict dead exports by pinger
 
        check_timeout || return 1
 
-       local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
-
-       echo starting with $OST_NEXP OST exports
 # OBD_FAIL_PTLRPC_DROP_RPC 0x505
        do_facet client lctl set_param fail_loc=0x505
-        # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
-        # But if there's a race to start the evictor from various obds,
-        # the loser might have to wait for the next ping.
-
+       local before=$(date +%s)
        local rc=0
-       wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
-       rc=$?
+
+       # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
+       # But if there's a race to start the evictor from various obds,
+       # the loser might have to wait for the next ping.
+       sleep $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
        do_facet client lctl set_param fail_loc=0x0
-        [ $rc -eq 0 ] || error "client not evicted from OST"
+       do_facet client df > /dev/null
+
+       local oscs=$(lctl dl | awk '/-osc-/ {print $4}')
+       check_clients_evicted $before ${oscs[@]}
+       check_clients_full 10 ${oscs[@]}
 }
 run_test 26a "evict dead exports"
 
@@ -1165,7 +1292,7 @@ run_test 52 "failover OST under load"
 # test of open reconstruct
 test_53() {
        touch $DIR/$tfile
-       drop_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
+       drop_mdt_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
                return 2
 }
 run_test 53 "touch: drop rep"
@@ -1189,6 +1316,13 @@ test_55() {
 
        mkdir -p $DIR/$tdir
 
+       # This test assumes relatively small max_dirty_mb setting
+       # which we want to walk away from, so just for it we will
+       # temporarily lower the value
+       local max_dirty_mb=$(lctl get_param -n osc.*.max_dirty_mb | head -n 1)
+       lctl set_param -n osc.*.max_dirty_mb=32
+       stack_trap "lctl set_param osc.*.max_dirty_mb=$max_dirty_mb" EXIT
+
        # Minimum pass speed is 2MBps
        local ddtimeout=64
        # LU-2887/LU-3089 - set min pass speed to 500KBps
@@ -1313,63 +1447,47 @@ test_59() { # bug 10589
 }
 run_test 59 "Read cancel race on client eviction"
 
-err17935 () {
-       # we assume that all md changes are in the MDT0 changelog
-       if [ $MDSCOUNT -gt 1 ]; then
-               error_ignore bz17935 $*
-       else
-               error $*
-       fi
-}
-
 test_60() {
-       MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid |
-               awk '{ gsub(/_UUID/,""); print $1 }' | head -n1)
-
-       NUM_FILES=15000
-       mkdir -p $DIR/$tdir
+       local num_files=${COUNT:-5000}
+       test_mkdir $DIR/$tdir
 
        # Register (and start) changelog
-       USER=$(do_facet $SINGLEMDS lctl --device $MDT0 changelog_register -n)
-       echo "Registered as $MDT0 changelog user $USER"
+       changelog_register || error "changelog_register failed"
 
        # Generate a large number of changelog entries
-       createmany -o $DIR/$tdir/$tfile $NUM_FILES
+       createmany -o $DIR/$tdir/$tfile $num_files
        sync
        sleep 5
 
        # Unlink files in the background
-       unlinkmany $DIR/$tdir/$tfile $NUM_FILES &
-       CLIENT_PID=$!
+       unlinkmany $DIR/$tdir/$tfile $num_files &
+       local client_pid=$!
        sleep 1
 
        # Failover the MDS while unlinks are happening
        facet_failover $SINGLEMDS
 
        # Wait for unlinkmany to finish
-       wait $CLIENT_PID
+       wait $client_pid
 
        # Check if all the create/unlink events were recorded
        # in the changelog
-       $LFS changelog $MDT0 >> $DIR/$tdir/changelog
-       local cl_count=$(grep UNLNK $DIR/$tdir/changelog | wc -l)
-       echo "$cl_count unlinks in $MDT0 changelog"
-
-       do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $USER
-       USERS=$(( $(do_facet $SINGLEMDS lctl get_param -n \
-           mdd.$MDT0.changelog_users | wc -l) - 2 ))
-       if [ $USERS -eq 0 ]; then
-           [ $cl_count -eq $NUM_FILES ] || \
-               err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
-           # Also make sure we can clear large changelogs
-           cl_count=$($LFS changelog $FSNAME | wc -l)
-           [ $cl_count -le 2 ] || \
-               error "Changelog not empty: $cl_count entries"
-       else
-           # If there are other users, there may be other unlinks in the log
-           [ $cl_count -ge $NUM_FILES ] || \
-               err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
-           echo "$USERS other changelog users; can't verify clear"
+       local cl_count=$(changelog_dump | grep -c UNLNK)
+       echo "$cl_count unlinks in changelog"
+
+       changelog_deregister || error "changelog_deregister failed"
+       if ! changelog_users $SINGLEMDS | grep -q "^cl"; then
+               [ $cl_count -eq $num_files ] ||
+                       error "Recorded $cl_count of $num_files unlinks"
+               # Also make sure we can clear large changelogs
+               cl_count=$(changelog_dump | wc -l)
+               [ $cl_count -le 2 ] ||
+                       error "Changelog not empty: $cl_count entries"
+       else # If other users, there may be other unlinks in the log
+               [ $cl_count -ge $num_files ] ||
+                       error "Recorded $cl_count of $num_files unlinks"
+               changelog_users $SINGLEMDS
+               echo "other changelog users; can't verify clear"
        fi
 }
 run_test 60 "Add Changelog entries during MDS failover"
@@ -1413,6 +1531,39 @@ run_test 61 "Verify to not reuse orphan objects - bug 17025"
 #}
 #run_test 62 "Verify connection flags race - bug LU-1716"
 
+test_65() {
+       mount_client $DIR2
+
+       #grant lock1, export2
+       $SETSTRIPE -i -0 $DIR2/$tfile || return 1
+       $MULTIOP $DIR2/$tfile Ow  || return 2
+
+#define OBD_FAIL_LDLM_BL_EVICT            0x31e
+       do_facet ost $LCTL set_param fail_loc=0x31e
+       #get waiting lock2, export1
+       $MULTIOP $DIR/$tfile Ow &
+       PID1=$!
+       # let enqueue to get asleep
+       sleep 2
+
+       #get lock2 blocked
+       $MULTIOP $DIR2/$tfile Ow &
+       PID2=$!
+       sleep 2
+
+       #evict export1
+       ost_evict_client
+
+       sleep 2
+       do_facet ost $LCTL set_param fail_loc=0
+
+       wait $PID1
+       wait $PID2
+
+       umount_client $DIR2
+}
+run_test 65 "lock enqueue for destroyed export"
+
 test_66()
 {
        [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.7.51) ]] ||
@@ -1425,7 +1576,7 @@ test_66()
 
        # drop 1 reply with UPDATE lock
        mcreate $DIR/$tfile || error "mcreate failed: $?"
-       drop_ldlm_reply_once "stat $DIR/$tfile" &
+       drop_mdt_ldlm_reply_once "stat $DIR/$tfile" &
        sleep 2
 
        # make the re-sent lock to sleep
@@ -1433,8 +1584,8 @@ test_66()
        do_nodes $list $LCTL set_param fail_loc=0x80000136
 
        #initiate the re-connect & re-send
-       local mdccli=$($LCTL dl | awk '/-mdc-/ {print $4;}')
-       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       local mdccli=$($LCTL dl | awk '/-MDT0000-mdc-/ {print $4;}')
+       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.conn_uuid)
        $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}"
        sleep 2
 
@@ -1446,38 +1597,24 @@ test_66()
 }
 run_test 66 "lock enqueue re-send vs client eviction"
 
-test_65() {
-       mount_client $DIR2
-
-       #grant lock1, export2
-       $SETSTRIPE -i -0 $DIR2/$tfile || return 1
-       $MULTIOP $DIR2/$tfile Ow  || return 2
-
-#define OBD_FAIL_LDLM_BL_EVICT            0x31e
-       do_facet ost $LCTL set_param fail_loc=0x31e
-       #get waiting lock2, export1
-       $MULTIOP $DIR/$tfile Ow &
-       PID1=$!
-       # let enqueue to get asleep
-       sleep 2
-
-       #get lock2 blocked
-       $MULTIOP $DIR2/$tfile Ow &
-       PID2=$!
-       sleep 2
-
-       #evict export1
-       ost_evict_client
+test_67()
+{
+#define OBD_FAIL_PTLRPC_CONNECT_RACE    0x531
+       $LCTL set_param fail_loc=0x80000531
 
+       local mdtname="MDT0000"
+       local mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
+       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}" &
        sleep 2
-       do_facet ost $LCTL set_param fail_loc=0
 
-       wait $PID1
-       wait $PID2
+       mds_evict_client
+       sleep 1
 
-       umount_client $DIR2
+       client_reconnect
+       wait
 }
-run_test 65 "lock enqueue for destroyed export"
+run_test 67 "connect vs import invalidate race"
 
 check_cli_ir_state()
 {
@@ -1623,26 +1760,45 @@ test_100()
 }
 run_test 100 "IR: Make sure normal recovery still works w/o IR"
 
-test_101()
+test_101a()
 {
-        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
-                { skip "MGS without IR support"; return 0; }
+       do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+               skip "MGS without IR support"
 
-        set_ir_status full
+       set_ir_status full
 
-        local OST1_IMP=$(get_osc_import_name client ost1)
+       local ost1_imp=$(get_osc_import_name client ost1)
 
-        # disable pinger recovery
-        lctl set_param -n osc.$OST1_IMP.pinger_recov=0
+       # disable pinger recovery
+       lctl set_param -n osc.$ost1_imp.pinger_recov=0
+       stack_trap "$LCTL set_param -n osc.$ost1_imp.pinger_recov=1" EXIT
 
-        fail ost1
+       fail ost1
 
-        target_instance_match ost1 || error "instance mismatch"
-        nidtbl_versions_match || error "version must match"
+       target_instance_match ost1 || error "instance mismatch"
+       nidtbl_versions_match || error "version must match"
+}
+run_test 101a "IR: Make sure IR works w/o normal recovery"
 
-        lctl set_param -n osc.$OST1_IMP.pinger_recov=1
+test_101b()
+{
+       do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+               skip "MGS without IR support"
+
+       set_ir_status full
+
+       local ost1_imp=$(get_osc_import_name client ost1)
+
+#define OBD_FAIL_OST_PREPARE_DELAY      0x247
+       do_facet ost1 "$LCTL set_param fail_loc=0x247"
+       # disable pinger recovery
+       $LCTL set_param -n osc.$ost1_imp.pinger_recov=0
+       stack_trap "$LCTL set_param -n osc.$ost1_imp.pinger_recov=1" EXIT
+
+#OST may return EAGAIN if it is not configured yet
+       fail ost1
 }
-run_test 101 "IR: Make sure IR works w/o normal recovery"
+run_test 101b "IR: Make sure IR works w/o normal recovery and proceed EAGAIN"
 
 test_102()
 {
@@ -1698,7 +1854,7 @@ test_103()
         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
                 { skip "MGS without IR support"; return 0; }
 
-        combined_mgs_mds && skip "mgs and mds on the same target" && return 0
+       combined_mgs_mds && skip "needs separate mgs and mds" && return 0
 
         # workaround solution to generate config log on the mds
         remount_facet mds1
@@ -1832,17 +1988,17 @@ test_106() { # LU-1789
        touch $DIR2/$tfile || error "failed to create empty file"
        replay_barrier $SINGLEMDS
 
-       $LCTL set_param debug=console
+       $LCTL set_param debug=ha
        $LCTL clear
        facet_failover $SINGLEMDS
 
-       # lightweight connection must be evicted
+       # lightweight goes through LUSTRE_IMP_RECOVER during failover
        touch -c $DIR2/$tfile || true
        $LCTL dk $TMP/lustre-log-$TESTNAME.log
-       evicted=`awk '/This client was evicted by .*MDT0000/ {
+       recovered=`awk '/MDT0000-mdc-[0-9a-f]*: lwp recover/ {
                                      print;
                      }' $TMP/lustre-log-$TESTNAME.log`
-       [ -z "$evicted" ] && error "lightweight client not evicted by mds"
+       [ -z "$recovered" ] && error "lightweight client was not recovered"
 
        # and all operations performed by lightweight client should be
        # synchronous, so the file created before mds restart should be there
@@ -1897,21 +2053,21 @@ run_test 108 "client eviction don't crash"
 test_110a () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
        local remote_dir=$DIR/$tdir/remote_dir
-       local MDTIDX=1
+       local mdtidx=1
        local num
 
        #prepare for 110 test, which need set striped dir on remote MDT.
        for num in $(seq $MDSCOUNT); do
                do_facet mds$num \
-                       lctl set_param -n mdt.${FSNAME}*.enable_remote_dir=1 \
+                       lctl set_param -n mdt.$FSNAME*.enable_remote_dir=1 \
                                2>/dev/null
        done
 
        mkdir -p $DIR/$tdir
-       drop_request "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
-                                       error "lfs mkdir failed"
-       local diridx=$($GETSTRIPE -M $remote_dir)
-       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+       drop_request "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
+               error "lfs mkdir failed"
+       local diridx=$($LFS getstripe -m $remote_dir)
+       [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 }
@@ -1920,14 +2076,14 @@ run_test 110a "create remote directory: drop client req"
 test_110b () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
        local remote_dir=$DIR/$tdir/remote_dir
-       local MDTIDX=1
+       local mdtidx=1
 
        mkdir -p $DIR/$tdir
-       drop_reint_reply "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
-                                       error "lfs mkdir failed"
+       drop_reint_reply "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
+               error "lfs mkdir failed"
 
-       diridx=$($GETSTRIPE -M $remote_dir)
-       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+       diridx=$($LFS getstripe -m $remote_dir)
+       [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 }
@@ -1936,14 +2092,14 @@ run_test 110b "create remote directory: drop Master rep"
 test_110c () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
        local remote_dir=$DIR/$tdir/remote_dir
-       local MDTIDX=1
+       local mdtidx=1
 
        mkdir -p $DIR/$tdir
-       drop_update_reply $MDTIDX "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
-                                               error "lfs mkdir failed"
+       drop_update_reply $mdtidx "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
+               error "lfs mkdir failed"
 
-       diridx=$($GETSTRIPE -M $remote_dir)
-       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+       diridx=$($GETSTRIPE -m $remote_dir)
+       [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 }
@@ -1995,24 +2151,27 @@ test_110f () {
 run_test 110f "remove remote directory: drop slave rep"
 
 test_110g () {
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.11.0) ]] ||
+               { skip "Need MDS version at least 2.11.0"; return 0; }
+
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       local remote_dir=$DIR/$tdir/remote_dir
-       local MDTIDX=1
 
-       mkdir -p $remote_dir
+       mkdir -p $DIR/$tdir
+       touch $DIR/$tdir/$tfile
 
-       createmany -o $remote_dir/f 100
+       # OBD_FAIL_MDS_REINT_NET_REP    0x119
+       do_facet mds1 $LCTL set_param fail_loc=0x119
+       $LFS migrate -m 1 $DIR/$tdir &
+       migrate_pid=$!
+       sleep 5
+       do_facet mds1 $LCTL set_param fail_loc=0
+       wait $migrate_pid
 
-       #define OBD_FAIL_MIGRATE_NET_REP                0x1800
-       do_facet mds$MDTIDX lctl set_param fail_loc=0x1800
-       $LFS migrate -m $MDTIDX $remote_dir || error "migrate failed"
-       do_facet mds$MDTIDX lctl set_param fail_loc=0x0
-
-       for file in $(find $remote_dir); do
-               mdt_index=$($LFS getstripe -M $file)
-               [ $mdt_index == $MDTIDX ] ||
-                       error "$file is not on MDT${MDTIDX}"
-       done
+       local mdt_index
+       mdt_index=$($LFS getstripe -m $DIR/$tdir)
+       [ $mdt_index == 1 ] || error "$tdir is not on MDT1"
+       mdt_index=$($LFS getstripe -m $DIR/$tdir/$tfile)
+       [ $mdt_index == 1 ] || error "$tfile is not on MDT1"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 }
@@ -2020,6 +2179,10 @@ run_test 110g "drop reply during migration"
 
 test_110h () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local server_version=$(lustre_version_code mds1)
+       [[ $server_version -ge $(version_code 2.7.56) ]] ||
+               { skip "Need MDS version at least 2.7.56"; return 0; }
+
        local src_dir=$DIR/$tdir/source_dir
        local tgt_dir=$DIR/$tdir/target_dir
        local MDTIDX=1
@@ -2044,6 +2207,10 @@ run_test 110h "drop update reply during cross-MDT file rename"
 
 test_110i () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local server_version=$(lustre_version_code mds1)
+       [[ $server_version -ge $(version_code 2.7.56) ]] ||
+               { skip "Need MDS version at least 2.7.56"; return 0; }
+
        local src_dir=$DIR/$tdir/source_dir
        local tgt_dir=$DIR/$tdir/target_dir
        local MDTIDX=1
@@ -2071,6 +2238,10 @@ run_test 110i "drop update reply during cross-MDT dir rename"
 
 test_110j () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       local server_version=$(lustre_version_code mds1)
+       [[ $server_version -ge $(version_code 2.7.56) ]] ||
+               { skip "Need MDS version at least 2.7.56"; return 0; }
+
        local remote_dir=$DIR/$tdir/remote_dir
        local local_dir=$DIR/$tdir/local_dir
        local MDTIDX=1
@@ -2095,13 +2266,14 @@ test_111 ()
        [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.62) ]] ||
                { skip "Need MDS version at least 2.3.62"; return 0; }
 
-       local mdsdev=$(mdsdevname ${SINGLEMDS//mds/})
 #define OBD_FAIL_MDS_CHANGELOG_INIT 0x151
        do_facet $SINGLEMDS lctl set_param fail_loc=0x151
        stop $SINGLEMDS || error "stop MDS failed"
-       start $SINGLEMDS $mdsdev && error "start MDS should fail"
+       start $SINGLEMDS $(mdsdevname ${SINGLEMDS//mds/}) &&
+               error "start MDS should fail"
        do_facet $SINGLEMDS lctl set_param fail_loc=0
-       start $SINGLEMDS $mdsdev || error "start MDS failed"
+       start $SINGLEMDS $(mdsdevname ${SINGLEMDS//mds/}) ||
+               error "start MDS failed"
 }
 run_test 111 "mdd setup fail should not cause umount oops"
 
@@ -2356,7 +2528,7 @@ test_113() {
        # drop 1 reply with UPDATE lock,
        # resend should not create 2nd lock on server
        mcreate $DIR/$tfile || error "mcreate failed: $?"
-       drop_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
+       drop_mdt_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
 
        # 2 BL AST will be sent to client, both must find the same lock,
        # race them to not get EINVAL for 2nd BL AST
@@ -2409,6 +2581,10 @@ test_130_base() {
 
 test_130a() {
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -ge $(version_code 2.7.2) ]] ||
+               { skip "Need server version newer than 2.7.1"; return 0; }
+
        test_130_base
 
        wait $T130_PID || [ $? -eq 0 ] && error "stat should fail"
@@ -2418,6 +2594,10 @@ run_test 130a "enqueue resend on not existing file"
 
 test_130b() {
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -ge $(version_code 2.7.2) ]] ||
+               { skip "Need server version newer than 2.7.1"; return 0; }
+
        test_130_base
        # let the reply to be dropped
        sleep 10
@@ -2514,6 +2694,7 @@ test_131() {
        # another IO under the same lock
        #define OBD_FAIL_OSC_DELAY_IO            0x414
        $LCTL set_param fail_loc=0x80000414
+       $LCTL set_param fail_val=4 fail_loc=0x80000414
        dd if=/dev/zero of=$DIR/$tfile count=1 conv=notrunc oflag=dsync &
        local pid=$!
        sleep 1
@@ -2539,8 +2720,8 @@ test_133() {
        multiop_bg_pause $DIR/$tfile O_jc || return 1
        PID=$!
 
-       #define OBD_FAIL_LDLM_REPLY              0x30c
-       do_nodes $list $LCTL set_param fail_loc=0x8000030c
+       #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
+       do_nodes $list $LCTL set_param fail_loc=0x80000157
        kill -USR1 $PID
        echo "waiting for multiop $PID"
        wait $PID || return 2
@@ -2551,6 +2732,106 @@ test_133() {
 }
 run_test 133 "don't fail on flock resend"
 
+test_134() {
+       [ -z "$CLIENTS" ] && skip "Need two or more clients" && return
+       [ $CLIENTCOUNT -lt 2 ] &&
+               { skip "Need 2+ clients, have $CLIENTCOUNT" && return; }
+
+       mkdir -p $MOUNT/$tdir/1 $MOUNT/$tdir/2 || error "mkdir failed"
+       touch $MOUNT/$tdir/1/$tfile $MOUNT/$tdir/2/$tfile ||
+               error "touch failed"
+       zconf_umount_clients $CLIENTS $MOUNT
+       zconf_mount_clients $CLIENTS $MOUNT
+
+#define OBD_FAIL_TGT_REPLY_DATA_RACE    0x722
+       # assume commit interval is 5
+       do_facet mds1 "$LCTL set_param fail_loc=0x722 fail_val=5"
+
+       local -a clients=(${CLIENTS//,/ })
+       local client1=${clients[0]}
+       local client2=${clients[1]}
+
+       do_node $client1 rm $MOUNT/$tdir/1/$tfile &
+       rmpid=$!
+       do_node $client2 mv $MOUNT/$tdir/2/$tfile $MOUNT/$tdir/2/${tfile}_2 &
+       mvpid=$!
+       fail mds1
+       wait $rmpid || error "rm failed"
+       wait $mvpid || error "mv failed"
+       return 0
+}
+run_test 134 "race between failover and search for reply data free slot"
+
+test_135() {
+       [ $MDS1_VERSION -lt $(version_code 2.12.51) ] &&
+               skip "Need MDS version at least 2.12.51"
+
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -E 1M -L mdt $DIR/$tdir
+       # to have parent dir write lock before open/resend
+       touch $DIR/$tdir/$tfile
+       #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
+       do_nodes $(comma_list $(mdts_nodes)) $LCTL set_param fail_loc=0x80000157
+       openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tdir/$tfile ||
+               error "Failed to open DOM file"
+}
+run_test 135 "DOM: open/create resend to return size"
+
+test_136() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       [[ $MDS1_VERSION -ge $(version_code 2.12.52) ]] ||
+               skip "Need MDS version at least 2.12.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local MDT0=$(facet_svc $SINGLEMDS)
+
+       local clog=$(do_facet mds1 $LCTL --device $MDT0 changelog_register -n)
+       [ -n "$clog" ] || error "changelog_register failed"
+       cl_mask=$(do_facet mds1 $LCTL get_param \
+                               mdd.$MDT0.changelog_mask -n)
+       changelog_chmask "ALL"
+
+       # generate some changelog records to accumulate
+       test_mkdir -i 0 -c 0 $DIR/$tdir || error "mkdir $tdir failed"
+       createmany -m $DIR/$tdir/$tfile 10000 ||
+               error "create $DIR/$tdir/$tfile failed"
+
+       local size1=$(do_facet $SINGLEMDS \
+                     $LCTL get_param -n mdd.$MDT0.changelog_size)
+       echo "Changelog size $size1"
+
+       #define OBD_FAIL_LLOG_PURGE_DELAY                   0x1318
+       do_nodes $mdts $LCTL set_param fail_loc=0x1318 fail_val=30
+
+       # launch changelog_deregister in background on MDS
+       do_facet mds1 "nohup $LCTL --device $MDT0 changelog_deregister $clog \
+                       > foo.out 2> foo.err < /dev/null &"
+       # give time to reach fail_loc
+       sleep 15
+
+       # fail_loc will make MDS sleep in the middle of changelog_deregister
+       # take this opportunity to abruptly kill MDS
+       FAILURE_MODE_save=$FAILURE_MODE
+       FAILURE_MODE=HARD
+       fail mds1
+       FAILURE_MODE=$FAILURE_MODE_save
+
+       do_nodes $mdts $LCTL set_param fail_loc=0x0 fail_val=0
+
+       local size2=$(do_facet $SINGLEMDS \
+                     $LCTL get_param -n mdd.$MDT0.changelog_size)
+       echo "Changelog size $size2"
+       local clog2=$(do_facet $SINGLEMDS "$LCTL get_param -n \
+                       mdd.$MDT0.changelog_users | grep $clog")
+       echo "After crash, changelog user $clog2"
+
+       [ -n "$clog2" -o $size2 -lt $size1 ] ||
+               error "changelog record count unchanged"
+
+       do_facet mds1 $LCTL set_param mdd.$MDT0.changelog_mask=\'$cl_mask\' -n
+}
+run_test 136 "changelog_deregister leaving pending records"
+
 complete $SECONDS
 check_and_cleanup_lustre
 exit_status